Graphics 320, 240, 16, 1 ; Metroid Pong version 1.0 by Eikon ***** 150 Line Compo *****
AppTitle "Metroid Pong version 1.0"
SetBuffer BackBuffer()
SeedRnd(MilliSecs())
Logo = LoadImage("logo.png") ; GFX
Ball1 = LoadAnimImage("ball1.png", 16, 16, 0, 8)
Paddle = LoadImage("paddle.png")
Brinstar = LoadImage("brinstar.png")
Crateria = LoadImage("crateria.png")
Norfair = LoadImage("norfair.png")
Explode = LoadAnimImage("explode.png", 32, 32, 0, 5)
Ripper = LoadAnimImage("ripper.png", 40, 14, 0, 6)
Fog = LoadImage("fog.png")
Hit1 = LoadSound("hit1.wav"): ; SFX
Thump = LoadSound("thump.wav")
.Reset
FlushKeys()
Cls
Global P1X = 0, P1Y = 104, P1D = 2, P1Score = 0, P2X = 315, P2Y = 104, P2D = 2, P2Score = 0 , BX = 152, BY = 112, Frame = 0, FX = 4, FY = 4, BD = Rand(1, 4), SB = 1 ,SF = 0, DL = 0 , BGX = 0, BGY = 0, BGD = Rand(1, 4), FogX = 0, FogY = 0, FogD = Rand(1, 4), Winner = 0, WaitTime=CreateTimer(25); Vars
.Title
SetBuffer FrontBuffer()
Cls
Channel = PlayMusic("title.mid")
DrawImage Logo, 75, 76
Text 5, 225, "Press Any Key"
If KeyDown(1) Then End
WaitKey()
Cls
Text 0, 0, "1) Brinstar 2) Crateria 3) Norfair"
Locate 0, 16
C = Input(">")
If C > 3 Or C < 1 Then C = 1
Text 0, 32, "[ Match Point ]"
Locate 0, 48
MP = Input("> ")
If MP < 1 Then MP = 1
Text 0, 64, "[ 1 or 2 Players ]"
Locate 0, 80
P = Input("> ")
If P > 2 Or P < 1 Then P = 1
Text 0, 96, "[Fog of Pong? 0/1]"
Locate 0, 110
FOP = Input("> ")
If FOP < 0 Or FOP > 1 Then FOP = 0
If P = 1 Then
	Text 0, 126, "[ CPU AI Level 1/3]"
	Locate 0, 142
	DL = Input("> ")
	If DL > 3 Or DL < 1 Then DL = 1
	DL = DL * 5
EndIf
SetBuffer BackBuffer()
StopChannel Channel
; Music
If C = 1 Then Channel = PlayMusic("brinstar.mid")
If C = 2 Then Channel = PlayMusic("crateria.mid")
If C = 3 Then Channel = PlayMusic("norfair.mid")
Timer = MilliSecs()
While Not KeyDown(1)
Timer = MilliSecs()
Cls
If C = 1 Then TileImage Brinstar, BGX, BGY ; BackGround
If C = 2 Then TileImage Crateria, BGX, BGY
If C = 3 Then TileImage Norfair, BGX, BGY
If SB = 1 Then DrawImage Explode, 154, 104, SF ; Spawn Ball
SF = SF + 1
If SF = 5 Then SB = 0
DrawImage Paddle, P1X, P1Y ; Paddles
DrawImage Paddle, P2X, P2Y
DrawImage Ball1, BX, BY, Frame ; Ball
Frame = Frame + 1
If Frame = 8 Then Frame = 0
If FOP = 1 Then TileImage Fog, FogX, FogY
Text 32, 0, P1Score ; Score
Text 320 - 64, 0, P2Score
If P1D = 0 Then P1Y = P1Y + 8 ; Directions
If P1D = 1 Then P1Y = P1Y - 8
If P = 2 Then
	If P2D = 0 Then P2Y = P2Y + 8
	If P2D = 1 Then P2Y = P2Y - 8
EndIf
If KeyDown(208) Then P1D = 0 ; P1 Input
If KeyDown(200) Then P1D = 1
If P = 1 Then CPUAI() ; CPU Control
If P = 2 Then ; P2 Input
	If KeyDown(31) Then P2D = 0
	If KeyDown(17) Then P2D = 1
EndIf
TempD = Rand(1, 100) ; BackGround Scrolling
If TempD = 50 Then BGD = Rand(1, 4)
If BGD = 1 Then BGX = BGX + 4
If BGD = 2 Then BGX = BGX - 4
If BGD = 3 Then BGY = BGY - 4
If BGD = 4 Then BGY = BGY + 4
If FOP = 1 Then ; Fog Scrolling
	TempF = Rand(1, 100)
	If TempF = 50 Then FogD = Rand(1, 4)
	If FogD = 1 Then FogX = FogX + 4
	If FogD = 2 Then FogX = FogX - 4
	If FogD = 3 Then FogY = FogY - 4
	If FogD = 4 Then FogY = FogY + 4
EndIf
If BD = 1 Then BX = BX - FX BY = BY - FY ; Ball Movement
If BD = 2 Then BX = BX + FX: BY = BY - FY
If BD = 3 Then BX = BX - FX: BY = BY + FY
If BD = 4 Then BX = BX + FX: BY = BY + FY
If P1Y <= -8 Then P1Y = P1Y + 8 ; Bounderies
If P1Y >= 248 - 32 Then P1Y = P1Y - 8
If P2Y <= -8 Then P2Y = P2Y + 8
If P2Y >= 248 - 32 Then P2Y = P2Y - 8
If BY <= 1 And BD = 1 Then BY = 2: BD = 3: FX = FX + Rand(0, 1): TempT = 1 
If BY >= 240 - 16 And BD = 4 Then BY = 240 - 17: BD = 2: FY = FY + Rand(0, 1): TempT = 1
If BY >= 240 - 16 And BD = 3 Then BY = 240 - 17: BD = 1: FX = FX + Rand(0, 1): TempT = 1
If BY <= 1 And BD = 2 Then BY = 2: BD = 4: FY = FY + Rand(0, 1): TempT = 1
If TempT = 1 Then PlaySound Thump: TempT = 0
If ImagesCollide(Paddle, P1X, P1Y, 0, Ball1, BX, BY, Frame) And BD = 1 Then BD = 2: FX = FX + Rand(0, 1): TempH = 1 
If ImagesCollide(Paddle, P1X, P1Y, 0, Ball1, BX, BY, Frame) And BD = 3 Then BD = 4: FY = FY + Rand(0, 1): TempH = 1 
If ImagesCollide(Paddle, P2X, P2Y, 0, Ball1, BX, BY, Frame) And BD = 2 Then BD = 1: FY = FY + Rand(0, 1): TempH = 1 
If ImagesCollide(Paddle, P2X, P2Y, 0, Ball1, BX, BY, Frame) And BD = 4 Then BD = 3: FX = FX + Rand(0, 1): TempH = 1 
If TempH = 1 Then PlaySound Hit1: TempH = 0
If FX > 18 Then FX = 18
If FY > 18 Then FY = 18
If BX < 0 - 16 Then P2Score = P2Score + 1: BX = 152: BY = 112: BD = Rand(1, 4): FX = 4: FY = 4 SF = 0: SB = 1
If BX > 320 Then P1Score = P1Score + 1: BX = 152: BY = 112: BD = Rand(1, 4): FX = 4: FY = 4 SF = 0: SB = 1
If P1Score = MP Then Winner = 1: Goto Winner
If P2Score = MP Then Winner = 2: Goto Winner
Flip
WaitTimer(WaitTime)
Wend
End
.Winner
SetBuffer FrontBuffer()
Cls
Repeat
If Winner = 1 Then Text 0, 0, "Player 1 Wins"
If Winner = 2 Then Text 0, 0, "Player 2 Wins"
Text 5, 225, "Press Enter"
Until KeyDown(28)
Goto Reset
Function CPUAI()
If BD = 1 Or BD = 3 Then
	If P2Y + 16 < 120 Then P2Y = P2Y + 1
	If P2Y + 16 > 120 Then P2Y = P2Y - 1
EndIf
If BD = 2 Or BD = 4 And BX > 160 Then
	If BY > P2Y + 16 Then P2Y = P2Y + DL
	If BY + 16 < P2Y + 16 Then P2Y = P2Y - DL
EndIf
End Function

	

	 